! ----------------
! Example program
! Automatic arrays
! ----------------
program test
  implicit none
  integer, parameter:: n=2,m=3
  integer:: i,j
  real(kind(1.d0)):: A(n,m),B(n,m)  
  do i = 1, n
     do j = 1, m
        call random_number(A(i,j))
        call random_number(B(i,j))
     end do
  end do

  print*,'before swap:'
  write(*,99) 'A',A
  write(*,99) 'B',B

  call swap(A,B,n,m)

  print*,' after swap:'
  write(*,99) 'A',A
  write(*,99) 'B',B

99 format(a3,/,3(2(1x,f0.3),/))
end program test



subroutine swap(A,B,n,m)
   implicit none
   integer, intent(in):: n,m
   real(kind(1.d0)):: A(n,m),B(n,m)
   real(kind(1.d0)):: C(n,m) ! automatic array
   C = A
   A = B
   B = C
end subroutine swap

