! -----------------------------------------------------
! World's simplest simulation :)
!
!  VERSION 10.2.2006
!  Vesa Apaja
!
! compiler: at least Intel and gnu 
! in shell, type 
! mkfifo fifo
! a.out &
! gnuplot < fifo
! Note: program won't end by itself, you have to kill it
! ------------------------------------------------------
program gnusimu
  implicit none
  integer, parameter:: n=100
  integer:: i
  real(kind(1.d0)):: r(2,n),dr(2)
  logical:: ok
  inquire(file='fifo',exist=ok)
  if(.not.ok) stop'make the fifo first, in shell type "mkfifo fifo"'
  r = 0.d0
  do
     open(12,file='fifo',status='old')
     write(12,*) "unset key"
     write(12,*) "set xra [-1:1]"
     write(12,*) "set yra [-1:1]"
     write(12,*) "set size ratio 1"
     write(12,*) "plot '-' w p 3"
     do i = 1, n
        write(12,*) r(:,i)
        ! get random movement
        call random_number(dr(1))
        call random_number(dr(2))
        ! now dr is in the range [0:1],
        ! shift it to the range [-0.5:0.5] 
        dr = dr - 0.5d0
        ! move particle i
        r(:,i) = r(:,i)+0.01d0*dr
        ! periodic boundary conditions
        where(r(:,i)<-1.d0) r(:,i)  = r(:,i)+2.d0
        where(r(:,i)> 1.d0) r(:,i)  = r(:,i)-2.d0
     end do
     write(12,*) 'e'        
     call flush(12)
  end do  
end program gnusimu
         
