! ------------------------------------
! Example program
! Namelist : how to read in parameters
! sample data file is "data"
! ------------------------------------
program test
  implicit none  
  integer:: natoms=100, ndim=3
  real(kind(1.d0)):: boxx=0.d0,boxy=0.d0,boxz=0.d0
  namelist /para/ natoms, ndim, boxx,boxy,boxz
  
  read(*,nml=para) 

  write(*,'(a21)') 'simulation parameters'
  write(*,'(21("="))') 
  write(*,98) 'natoms',natoms
  write(*,98) 'ndim',ndim
  write(*,99) 'boxx',boxx
  write(*,99) 'boxy',boxy
  write(*,99) 'boxz',boxz

98 format(a10," = ",i8)
99 format(a10," = ",f8.3)
end program test

! example:
! in file "data":
!&para
!ndim = 2,
!natoms = 100,
!boxx = 12.d0,
!boxy = 10.d0
!/
!
! and program is run
! a.out<data
!

