! -----------------------------------------------------------
! Example program
!
! Demonstrates how one can 
! take only part of a module.
! -----------------------------------------------------------

module params
  integer, parameter:: dp=kind(1.d0)  
  real(dp),parameter:: pi=3.141592653589793238d0
  real(dp):: bigtable(10000)
end module params


program test  
  use params, only: dp,pi  ! take only dp and pi 
  implicit none
  real(dp):: pi2 
  pi2 = pi**2
  print*,'This is pi**2 :',pi2
  ! 
  ! "bigtable" was not taken from the module, it cannot be used. 
  ! Try uncommenting the next line and the compiler will complain.
  ! bigtable = 0.d0
end program test
